**Cette page a été importée automatiquement de notre ancien wiki mais n'a pas encore été révisée.**

## Utilisation de Tsung

[Manuel de Tsung](http://tsung.erlang-projects.org/user_manual.html)

### Installation

~~~
# aptitude install tsung
~~~

### Enregistrement d'une session

~~~
$ tsung-recorder start
...
$ tsung-recorder stop
~~~

Compléter les entêtes XML grâces aux exemples dans /usr/share/doc/tsung/examples/

Un exemple :


~~~
<?xml version="1.0"?>                                                                       
<!DOCTYPE tsung SYSTEM "/usr/share/tsung/tsung-1.0.dtd">                                    
<tsung loglevel="notice" version="1.0">                                                     
                                                                                            
  <!-- Client side setup -->                                                                
  <clients>                                                                                 
    <client host="mamachine" maxusers="30000"/>                                            
  </clients>                                                                                
                                                                                            
  <!-- Server side setup -->                                                                
<servers>                                                                                   
  <server host="www.test.com" port="80" type="tcp"></server>                          
</servers>                                                                                  
                                                                                            
                                                                                            
<load duration="5" unit="minute">                                                          
  <arrivalphase phase="1" duration="5" unit="minute">                                       
    <users interarrival="1" unit="second"></users>     
   </arrivalphase>                         
</load>                                                                                     

<sessions>                                                                                  
<session name='test' probability='100'  type='ts_http'>   
<request><http url='<http://www.example.com'> version='1.1' method='GET'></<http></request>
[…]
</session>
</sessions>
</tsung>
~~~


### Rejouer des sessions

~~~
tsung -f tsung-toto.xml start
~~~

### Générer les stats

~~~
cd ~/.tsung/log/20081103-16:21
/usr/lib/tsung/bin/tsung_stats.pl
~~~

### Améliorer les performances de Tsung

* ulimit
* Baisser le loglevel

### Mode multi clients

Il faut pouvoir se connecter en ssh via clé et sans passphrase.[[BR]]

Il faut que le nom de machine du master résout sur les slaves. (On pourra modifier le fichier hosts).[[BR]]

/!\ Il faut la même version de tsung et erlang et des librairies sur chaque machine.[[BR]]

/!\ Il ne faut pas de pare-feu, des ports dynamiques sont ouverts pour communiquer entre le master et les slaves.