# Practice Symfony

<http://symfony.com/>

## Prérequis

### Apache

Symfony contient des fichiers `.htaccess` avec des directives DirectoryIndex, Options -MultiViews, Rewrite*, Deny.

La configuration Apache du VirtualHost doit donc contenir au minimum :

~~~{.apache}
AllowOverride Limit FileInfo Indexes Options=All,MultiViews
~~~

### PHP

<http://symfony.com/doc/current/reference/requirements.html>

Le paquet **php5-json** doit être installé.

Il faut indiquer le paramètre `date.timezone = "Europe/Paris"` dans les fichiers de configuration PHP :

- `/etc/php5/apache2/php.ini`
- `/etc/php5/cli/php.ini`

Pour tester la configuration PHP, des tests peuvent être lancés ainsi :

~~~
$ php bin/symfony_requirements
~~~
